Datetime

- Main Page
- Related Pages
- Data Structures
- Files
- Examples

Enumerations | Functions
Datetime

## Enumerations

## Functions
EOAPI void | elm_obj_datetime_format_set (const char *fmt)
| Set the datetime format. More...
EOAPI const char * | elm_obj_datetime_format_get (void)
| Get the datetime format. More...
EOAPI void | elm_obj_datetime_field_limit_set (Elm_Datetime_Field_Type fieldtype, int min, int max)
| Set the field limits of a field. More...
EOAPI void | elm_obj_datetime_field_limit_get (Elm_Datetime_Field_Type fieldtype, int *min, int *max)
| Get the field limits of a field. More...
EOAPI Eina_Bool | elm_obj_datetime_value_min_set (const Elm_Datetime_Time *mintime)
| Set the lower boundary of a field. More...
EOAPI Eina_Bool | elm_obj_datetime_value_min_get (Elm_Datetime_Time *mintime)
| Get the lower boundary of a field. More...
EOAPI Eina_Bool | elm_obj_datetime_value_set (const Elm_Datetime_Time *newtime)
| Set the current value of a Datetime object. More...
EOAPI Eina_Bool | elm_obj_datetime_value_get (Elm_Datetime_Time *currtime)
| Get the current value of a Datetime object. More...
EOAPI void | elm_obj_datetime_field_visible_set (Elm_Datetime_Field_Type fieldtype, Eina_Bool visible)
| Set a field to be visible or not. More...
EOAPI Eina_Bool | elm_obj_datetime_field_visible_get (Elm_Datetime_Field_Type fieldtype)
| Get whether a field can be visible/not. More...
EOAPI Eina_Bool | elm_obj_datetime_value_max_set (const Elm_Datetime_Time *maxtime)
| Set the upper boundary of a field. More...
EOAPI Eina_Bool | elm_obj_datetime_value_max_get (Elm_Datetime_Time *maxtime)
| Get the upper boundary of a field. More...
void | elm_datetime_format_set (Elm_Datetime *obj, const char *fmt)
| Set the datetime format. More...
const char * | elm_datetime_format_get (const Elm_Datetime *obj)
| Get the datetime format. More...
void | elm_datetime_field_limit_set (Elm_Datetime *obj, Elm_Datetime_Field_Type fieldtype, int min, int max)
| Set the field limits of a field. More...
void | elm_datetime_field_limit_get (const Elm_Datetime *obj, Elm_Datetime_Field_Type fieldtype, int *min, int *max)
| Get the field limits of a field. More...
Eina_Bool | elm_datetime_value_min_set (Elm_Datetime *obj, const Elm_Datetime_Time *mintime)
| Set the lower boundary of a field. More...
Eina_Bool | elm_datetime_value_min_get (const Elm_Datetime *obj, Elm_Datetime_Time *mintime)
| Get the lower boundary of a field. More...
Eina_Bool | elm_datetime_value_set (Elm_Datetime *obj, const Elm_Datetime_Time *newtime)
| Set the current value of a Datetime object. More...
Eina_Bool | elm_datetime_value_get (const Elm_Datetime *obj, Elm_Datetime_Time *currtime)
| Get the current value of a Datetime object. More...
void | elm_datetime_field_visible_set (Elm_Datetime *obj, Elm_Datetime_Field_Type fieldtype, Eina_Bool visible)
| Set a field to be visible or not. More...
Eina_Bool | elm_datetime_field_visible_get (const Elm_Datetime *obj, Elm_Datetime_Field_Type fieldtype)
| Get whether a field can be visible/not. More...
Eina_Bool | elm_datetime_value_max_set (Elm_Datetime *obj, const Elm_Datetime_Time *maxtime)
| Set the upper boundary of a field. More...
Eina_Bool | elm_datetime_value_max_get (const Elm_Datetime *obj, Elm_Datetime_Time *maxtime)
| Get the upper boundary of a field. More...
Evas_Object * | elm_datetime_add (Evas_Object *parent)
| Adds a new datetime Widget. More...

## Detailed Description

Datetime widget is used to display and input date & time values. This widget displays date and time as per the system's locale settings (Date includes Day, Month & Year along with the defined separators and Time includes Hour, Minute & AM/PM fields. Separator for AM/PM field is ignored.

The corresponding Month, AM/PM strings are displayed according to the system’s language settings.

Datetime format is a combination of LIBC standard characters like “%d %b %Y %I : %M %p” which, as a whole represents both Date as well as Time format.

Elm_datetime supports only the following sub set of libc date format specifiers:

%Y : The year as a decimal number including the century (example: 2011).

%y : The year as a decimal number without a century (range 00 to 99)

%m : The month as a decimal number (range 01 to 12).

%b : The abbreviated month name according to the current locale.

%B : The full month name according to the current locale.

%h : The abbreviated month name according to the current locale(same as %b).

%d : The day of the month as a decimal number (range 01 to 31).

%e : The day of the month as a decimal number (range 1 to 31). single digits are preceded by a blank.

%I : The hour as a decimal number using a 12-hour clock (range 01 to 12).

%H : The hour as a decimal number using a 24-hour clock (range 00 to 23).

%k : The hour (24-hour clock) as a decimal number (range 0 to 23). single digits are preceded by a blank.

%l : The hour (12-hour clock) as a decimal number (range 1 to 12); single digits are preceded by a blank.

%M : The minute as a decimal number (range 00 to 59).

%p : Either 'AM' or 'PM' according to the given time value, or the corresponding strings for the current locale. Noon is treated as 'PM' and midnight as 'AM'

%P : Like p but in lower case: 'am' or 'pm' or a corresponding string for the current locale.

%c : The preferred date and time representation for the current locale.

%x : The preferred date representation for the current locale without the time.

%X : The preferred time representation for the current locale without the date.

%r : The complete calendar time using the AM/PM format of the current locale.

%R : The hour and minute in decimal numbers using the format H:M.

%T : The time of day in decimal numbers using the format H:M:S.

%D : The date using the format %m/%d/%y.

%F : The date using the format %Y-%m-%d.

(For more reference on the available LIBC date format specifiers, please visit the link: http://www.gnu.org/s/hello/manual/libc.html#Formatting-Calendar-Time )

Datetime widget can provide Unicode separators in between its fields except for AM/PM field. A separator can be any Unicode character other than the LIBC standard date format specifiers.( Example: In the format %b %d , %y %H : %M comma(,) is separator for date field %d and colon(:) is separator for hour field %H ).

The default format is a predefined one, based on the system Locale.

Hour format 12hr(1-12) or 24hr(0-23) display can be selected by setting the corresponding user format.

Datetime supports six fields: Year, Month, Date, Hour, Minute, AM/PM. Depending on the Datetime module that is loaded, the user can see different UI to select the individual field values.

The individual fields of Datetime can be arranged in any order according to the format set by application.

There is a provision to set the visibility of a particular field as TRUE/ FALSE so that only time/ only date / only required fields will be displayed.

Each field is having a default minimum and maximum values just like the daily calendar information. These min/max values can be modified as per the application usage.

User can enter the values only in between the range of maximum and minimum. Apart from these APIs, there is a provision to display only a limited set of values out of the possible values. APIs to select the individual field limits are intended for this purpose.

The whole widget is left aligned and its size grows horizontally depending on the current format and each field's visible/disabled state.

Datetime individual field selection is implemented in a modular style. Module can be implemented as a Ctxpopup based selection or an ISE based selection or even a spinner like selection etc.

Datetime Module design:

The following functions are expected to be implemented in a Datetime module:

Field creation:

     __________                                            __________
    |          |----- obj_hook() ---------------------->>>|          |
    |          |<<<----------------returns Mod_data ------|          |
    | Datetime |_______                                   |          |
    |  widget  |       |Assign module call backs          |  Module  |
    |   base   |<<<____|                                  |          |
    |          |                                          |          |
    |          |----- field_create() ------------------>>>|          |
    |__________|<<<----------------returns field_obj -----|__________|

Field value setting:

     __________                                          __________
    |          |                                        |          |
    | Datetime |<<<----------elm_datetime_value_set()---|          |
    |  widget  |                                        |  Module  |
    |   base   |----display_field_value()------------>>>|          |
    |__________|                                        |__________|

del_hook:

     __________                                          __________
    |          |                                        |          |
    | Datetime |----obj_unhook()-------------------->>>>|          |
    |  widget  |                                        |  Module  |
    |   base   |         <<<-----frees mod_data---------|          |
    |__________|                                        |__________|

Any module can use the following shared functions that are implemented in elm_datetime.c :

field_format_get() - gives the field format.

field_limit_get() - gives the field minimum, maximum limits.

To enable a module, set the ELM_MODULES environment variable as shown:

export ELM_MODULES="datetime_input_ctxpopup>datetime/api"

This widget inherits from the Layout one, so that all the functions acting on it also work for datetime objects.

This widget emits the following signals, besides the ones sent from Layout:

- "changed" - whenever Datetime field value is changed, this signal is sent.
- "language,changed" - whenever system locale changes, this signal is sent.
- `"focused"` - When the datetime has received focus. (since 1.8)
- `"unfocused"` - When the datetime has lost focus. (since 1.8)

Here is an example on its usage:

- Datetime widget example

## Enumeration Type Documentation

enum Elm_Datetime_Field_Type

Identifies a Datetime field, The widget supports 6 fields : Year, month, Date, Hour, Minute, AM/PM.

Enumerator
ELM_DATETIME_MONTH | Indicates Year field.
ELM_DATETIME_DATE | Indicates Month field.
ELM_DATETIME_HOUR | Indicates Date field.
ELM_DATETIME_MINUTE | Indicates Hour field.
ELM_DATETIME_AMPM | Indicates Minute field.
ELM_DATETIME_MONTH | Indicates Year field.
ELM_DATETIME_DATE | Indicates Month field.
ELM_DATETIME_HOUR | Indicates Date field.
ELM_DATETIME_MINUTE | Indicates Hour field.
ELM_DATETIME_AMPM | Indicates Minute field.

enum Elm_Datetime_Field_Type

Identifies a Datetime field, The widget supports 6 fields : Year, month, Date, Hour, Minute, AM/PM.

Enumerator
ELM_DATETIME_MONTH | Indicates Year field.
ELM_DATETIME_DATE | Indicates Month field.
ELM_DATETIME_HOUR | Indicates Date field.
ELM_DATETIME_MINUTE | Indicates Hour field.
ELM_DATETIME_AMPM | Indicates Minute field.
ELM_DATETIME_MONTH | Indicates Year field.
ELM_DATETIME_DATE | Indicates Month field.
ELM_DATETIME_HOUR | Indicates Date field.
ELM_DATETIME_MINUTE | Indicates Hour field.
ELM_DATETIME_AMPM | Indicates Minute field.

## Function Documentation

Evas_Object* elm_datetime_add | ( | Evas_Object * | parent | ) |

Adds a new datetime Widget.

The default datetime format and corresponding strings are based on current locale.

Parameters

  parent | The parent object

Returns
  The new object or NULL if it cannot be created

This function inserts a new datetime widget on the canvas.

References ELM_DATETIME_AMPM, elm_layout_content_set(), elm_layout_content_unset(), elm_layout_signal_emit(), and elm_layout_sizing_eval().

void elm_datetime_field_limit_get | ( | const Elm_Datetime * | obj,
|  | Elm_Datetime_Field_Type | fieldtype,
|  | int * | min,
|  | int * | max
| ) |  |

Get the field limits of a field.

Limits can be set to individual fields, independently, except for AM/PM field. Any field can display the values only in between these minimum and maximum limits unless the corresponding time value is restricted from MinTime to MaxTime. That is, min/max field limits always works under the limitations of mintime/maxtime.

There is no provision to set the limits of AM/PM field.

Parameters

  [out] | min | Reference to field's minimum value.
  [out] | max | Reference to field's maximum value.

References elm_obj_datetime_field_limit_get().

void elm_datetime_field_limit_set | ( | Elm_Datetime * | obj,
|  | Elm_Datetime_Field_Type | fieldtype,
|  | int | min,
|  | int | max
| ) |  |

Set the field limits of a field.

Limits can be set to individual fields, independently, except for AM/PM field. Any field can display the values only in between these minimum and maximum limits unless the corresponding time value is restricted from MinTime to MaxTime. That is, min/max field limits always works under the limitations of mintime/maxtime.

There is no provision to set the limits of AM/PM field.

Parameters

  [in] | min | Reference to field's minimum value.
  [in] | max | Reference to field's maximum value.

References elm_obj_datetime_field_limit_set().

Eina_Bool elm_datetime_field_visible_get | ( | const Elm_Datetime * | obj,
|  | Elm_Datetime_Field_Type | fieldtype
| ) |  |

Get whether a field can be visible/not.

Parameters

  [in] | fieldtype | Type of the field. #ELM_DATETIME_YEAR etc.

Returns
  `true`, if field can be visible. `false` otherwise.

References elm_obj_datetime_field_visible_get().

void elm_datetime_field_visible_set | ( | Elm_Datetime * | obj,
|  | Elm_Datetime_Field_Type | fieldtype,
|  | Eina_Bool | visible
| ) |  |

Set a field to be visible or not.

Setting this API to `true` does not ensure that the field is visible, apart from this, the field's format must be present in Datetime overall format. If a field's visibility is set to `false` then it won't appear even though its format is present in overall format. So if and only if this API is set true and the corresponding field's format is present in Datetime format, the field is visible.

By default the field visibility is set to `true`.

Parameters

  [in] | visible | `true` field can be visible, `false` otherwise.

References elm_obj_datetime_field_visible_set().

const char* elm_datetime_format_get | ( | const Elm_Datetime * | obj | ) |

Get the datetime format.

Returns
  The datetime format.

References elm_obj_datetime_format_get().

void elm_datetime_format_set | ( | Elm_Datetime * | obj,
|  | const char * | fmt
| ) |  |

Set the datetime format.

Format is a combination of allowed Libc date format specifiers like: "%b %d, %Y %I : %M %p".

Maximum allowed format length is 64 chars.

Format can include separators for each individual datetime field except for AM/PM field.

Each separator can be a maximum of 6 UTF-8 bytes. Space is also taken as a separator.

These specifiers can be arranged in any order and the widget will display the fields accordingly.

Default format is taken as per the system locale settings.

Parameters

  [in] | fmt | The datetime format.

References elm_obj_datetime_format_set().

Eina_Bool elm_datetime_value_get | ( | const Elm_Datetime * | obj,
|  | Elm_Datetime_Time * | currtime
| ) |  |

Get the current value of a Datetime object.

Year: years since 1900. Negative value represents year below 1900 (year value -30 represents 1870). Year default range is from 70 to 137.

Month: default value range is from 0 to 11.

Date: default value range is from 1 to 31 according to the month value.

Hour: default value will be in terms of 24 hr format (0~23)

Minute: default value range is from 0 to 59.

Parameters

  [in,out] | currtime | Time structure.

Returns
  `true` if current time is returned successfully.

References elm_obj_datetime_value_get().

Eina_Bool elm_datetime_value_max_get | ( | const Elm_Datetime * | obj,
|  | Elm_Datetime_Time * | maxtime
| ) |  |

Get the upper boundary of a field.

Year: years since 1900. Negative value represents year below 1900 (year value -30 represents 1870). Year default range is from 70 to 137.

Month: default value range is from 0 to 11.

Date: default value range is from 1 to 31 according to the month value.

Hour: default value will be in terms of 24 hr format (0~23)

Minute: default value range is from 0 to 59.

Parameters

  [in,out] | maxtime | Time structure containing the maximum time value.

Returns
  `true` if maximum value is returned successfully.

References elm_obj_datetime_value_max_get().

Eina_Bool elm_datetime_value_max_set | ( | Elm_Datetime * | obj,
|  | const Elm_Datetime_Time * | maxtime
| ) |  |

Set the upper boundary of a field.

Year: years since 1900. Negative value represents year below 1900 (year value -30 represents 1870). Year default range is from 70 to 137.

Month: default value range is from 0 to 11.

Date: default value range is from 1 to 31 according to the month value.

Hour: default value will be in terms of 24 hr format (0~23)

Minute: default value range is from 0 to 59.

Parameters

  [in] | maxtime | Time structure containing the maximum time value.

Returns
  `true` if maximum value is accepted.

References elm_obj_datetime_value_max_set().

Eina_Bool elm_datetime_value_min_get | ( | const Elm_Datetime * | obj,
|  | Elm_Datetime_Time * | mintime
| ) |  |

Get the lower boundary of a field.

Year: years since 1900. Negative value represents year below 1900 (year value -30 represents 1870). Year default range is from 70 to 137.

Month: default value range is from 0 to 11.

Date: default value range is from 1 to 31 according to the month value.

Hour: default value will be in terms of 24 hr format (0~23)

Minute: default value range is from 0 to 59.

Parameters

  [in,out] | mintime | Time structure.

Returns
  `true` if minimum value is successfully returned.

References elm_obj_datetime_value_min_get().

Eina_Bool elm_datetime_value_min_set | ( | Elm_Datetime * | obj,
|  | const Elm_Datetime_Time * | mintime
| ) |  |

Set the lower boundary of a field.

Year: years since 1900. Negative value represents year below 1900 (year value -30 represents 1870). Year default range is from 70 to 137.

Month: default value range is from 0 to 11.

Date: default value range is from 1 to 31 according to the month value.

Hour: default value will be in terms of 24 hr format (0~23)

Minute: default value range is from 0 to 59.

Parameters

  [in] | mintime | Time structure containing the minimum time value.

Returns
  `true` if minimum value is accepted.

References elm_obj_datetime_value_min_set().

Eina_Bool elm_datetime_value_set | ( | Elm_Datetime * | obj,
|  | const Elm_Datetime_Time * | newtime
| ) |  |

Set the current value of a Datetime object.

Year: years since 1900. Negative value represents year below 1900 (year value -30 represents 1870). Year default range is from 70 to 137.

Month: default value range is from 0 to 11.

Date: default value range is from 1 to 31 according to the month value.

Hour: default value will be in terms of 24 hr format (0~23)

Minute: default value range is from 0 to 59.

Parameters

  [in] | newtime | Time structure filled with values to be set.

Returns
  `true` if current time is set successfully.

References elm_obj_datetime_value_set().

EOAPI void elm_obj_datetime_field_limit_get | ( | Elm_Datetime_Field_Type | fieldtype,
|  | int * | min,
|  | int * | max
| ) |  |

Get the field limits of a field.

Limits can be set to individual fields, independently, except for AM/PM field. Any field can display the values only in between these minimum and maximum limits unless the corresponding time value is restricted from MinTime to MaxTime. That is, min/max field limits always works under the limitations of mintime/maxtime.

There is no provision to set the limits of AM/PM field.

Parameters

  [out] | min | Reference to field's minimum value.
  [out] | max | Reference to field's maximum value.

Referenced by elm_datetime_field_limit_get().

EOAPI void elm_obj_datetime_field_limit_set | ( | Elm_Datetime_Field_Type | fieldtype,
|  | int | min,
|  | int | max
| ) |  |

Set the field limits of a field.

Limits can be set to individual fields, independently, except for AM/PM field. Any field can display the values only in between these minimum and maximum limits unless the corresponding time value is restricted from MinTime to MaxTime. That is, min/max field limits always works under the limitations of mintime/maxtime.

There is no provision to set the limits of AM/PM field.

Parameters

  [in] | min | Reference to field's minimum value.
  [in] | max | Reference to field's maximum value.

Referenced by elm_datetime_field_limit_set().

EOAPI Eina_Bool elm_obj_datetime_field_visible_get | ( | Elm_Datetime_Field_Type | fieldtype | ) |

Get whether a field can be visible/not.

Parameters

  [in] | fieldtype | Type of the field. #ELM_DATETIME_YEAR etc.

Returns
  `true`, if field can be visible. `false` otherwise.

Referenced by elm_datetime_field_visible_get().

EOAPI void elm_obj_datetime_field_visible_set | ( | Elm_Datetime_Field_Type | fieldtype,
|  | Eina_Bool | visible
| ) |  |

Set a field to be visible or not.

Setting this API to `true` does not ensure that the field is visible, apart from this, the field's format must be present in Datetime overall format. If a field's visibility is set to `false` then it won't appear even though its format is present in overall format. So if and only if this API is set true and the corresponding field's format is present in Datetime format, the field is visible.

By default the field visibility is set to `true`.

Parameters

  [in] | visible | `true` field can be visible, `false` otherwise.

Referenced by elm_datetime_field_visible_set().

EOAPI const char* elm_obj_datetime_format_get | ( | void |  | ) |

Get the datetime format.

Returns
  The datetime format.

Referenced by elm_datetime_format_get().

EOAPI void elm_obj_datetime_format_set | ( | const char * | fmt | ) |

Set the datetime format.

Format is a combination of allowed Libc date format specifiers like: "%b %d, %Y %I : %M %p".

Maximum allowed format length is 64 chars.

Format can include separators for each individual datetime field except for AM/PM field.

Each separator can be a maximum of 6 UTF-8 bytes. Space is also taken as a separator.

These specifiers can be arranged in any order and the widget will display the fields accordingly.

Default format is taken as per the system locale settings.

Parameters

  [in] | fmt | The datetime format.

Referenced by elm_datetime_format_set().

EOAPI Eina_Bool elm_obj_datetime_value_get | ( | Elm_Datetime_Time * | currtime | ) |

Get the current value of a Datetime object.

Year: years since 1900. Negative value represents year below 1900 (year value -30 represents 1870). Year default range is from 70 to 137.

Month: default value range is from 0 to 11.

Date: default value range is from 1 to 31 according to the month value.

Hour: default value will be in terms of 24 hr format (0~23)

Minute: default value range is from 0 to 59.

Parameters

  [in,out] | currtime | Time structure.

Returns
  `true` if current time is returned successfully.

Referenced by elm_datetime_value_get().

EOAPI Eina_Bool elm_obj_datetime_value_max_get | ( | Elm_Datetime_Time * | maxtime | ) |

Get the upper boundary of a field.

Year: years since 1900. Negative value represents year below 1900 (year value -30 represents 1870). Year default range is from 70 to 137.

Month: default value range is from 0 to 11.

Date: default value range is from 1 to 31 according to the month value.

Hour: default value will be in terms of 24 hr format (0~23)

Minute: default value range is from 0 to 59.

Parameters

  [in,out] | maxtime | Time structure containing the maximum time value.

Returns
  `true` if maximum value is returned successfully.

Referenced by elm_datetime_value_max_get().

EOAPI Eina_Bool elm_obj_datetime_value_max_set | ( | const Elm_Datetime_Time * | maxtime | ) |

Set the upper boundary of a field.

Year: years since 1900. Negative value represents year below 1900 (year value -30 represents 1870). Year default range is from 70 to 137.

Month: default value range is from 0 to 11.

Date: default value range is from 1 to 31 according to the month value.

Hour: default value will be in terms of 24 hr format (0~23)

Minute: default value range is from 0 to 59.

Parameters

  [in] | maxtime | Time structure containing the maximum time value.

Returns
  `true` if maximum value is accepted.

Referenced by elm_datetime_value_max_set().

EOAPI Eina_Bool elm_obj_datetime_value_min_get | ( | Elm_Datetime_Time * | mintime | ) |

Get the lower boundary of a field.

Year: years since 1900. Negative value represents year below 1900 (year value -30 represents 1870). Year default range is from 70 to 137.

Month: default value range is from 0 to 11.

Date: default value range is from 1 to 31 according to the month value.

Hour: default value will be in terms of 24 hr format (0~23)

Minute: default value range is from 0 to 59.

Parameters

  [in,out] | mintime | Time structure.

Returns
  `true` if minimum value is successfully returned.

Referenced by elm_datetime_value_min_get().

EOAPI Eina_Bool elm_obj_datetime_value_min_set | ( | const Elm_Datetime_Time * | mintime | ) |

Set the lower boundary of a field.

Year: years since 1900. Negative value represents year below 1900 (year value -30 represents 1870). Year default range is from 70 to 137.

Month: default value range is from 0 to 11.

Date: default value range is from 1 to 31 according to the month value.

Hour: default value will be in terms of 24 hr format (0~23)

Minute: default value range is from 0 to 59.

Parameters

  [in] | mintime | Time structure containing the minimum time value.

Returns
  `true` if minimum value is accepted.

Referenced by elm_datetime_value_min_set().

EOAPI Eina_Bool elm_obj_datetime_value_set | ( | const Elm_Datetime_Time * | newtime | ) |

Set the current value of a Datetime object.

Year: years since 1900. Negative value represents year below 1900 (year value -30 represents 1870). Year default range is from 70 to 137.

Month: default value range is from 0 to 11.

Date: default value range is from 1 to 31 according to the month value.

Hour: default value will be in terms of 24 hr format (0~23)

Minute: default value range is from 0 to 59.

Parameters

  [in] | newtime | Time structure filled with values to be set.

Returns
  `true` if current time is set successfully.

Referenced by elm_datetime_value_set().